/*
 *   Copyright (C) 2006 
 *   Siraj Razick <siraj@kdemail.net>
 *   PhobosK <phobosk@mail.kbfx.org>
 *   see Also ATHORS 
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "kbfxplasmacanvasitemwrapper.h"
#include "kbfxplasmaskinmanager.h"
#include <qptrlist.h>

KbfxPlasmaCanvasItemWrapper::KbfxPlasmaCanvasItemWrapper (QCanvas * canvas)
{
  m_canvas = canvas;
}

KbfxPlasmaCanvasItemWrapper::~KbfxPlasmaCanvasItemWrapper ()
{

}

QCanvasItem *
KbfxPlasmaCanvasItemWrapper::item (KbfxPlasmaCanvasItem::Type __type)
{

  if (__type == KbfxPlasmaCanvasItem::SEPARATOR)
    {
	static QCanvasPixmapArray  itemPixArray (KbfxPlasmaSkinManager::
						      getThemePixmapPath
						      (KbfxPlasmaSkinManager::
						       SEPARATOR));
      KbfxPlasmaCanvasItem *_ret =
	new KbfxPlasmaCanvasItem (&itemPixArray,m_canvas);
      _ret->setType (__type);
      return (QCanvasItem *) _ret;
    }

  if (__type == KbfxPlasmaCanvasItem::EXECUTABLE)
    {
      static QCanvasPixmapArray _pArray ( KbfxPlasmaSkinManager::
				getThemePixmapPath (KbfxPlasmaSkinManager::
						    TILENORMAL));

   QCanvasPixmap  * img1 = new QCanvasPixmap (KbfxPlasmaSkinManager::
					    getThemePixmapPath
					    (KbfxPlasmaSkinManager::
					     TILEHOVER));
      _pArray.setImage (1,img1);
      KbfxPlasmaCanvasItem *_ret = new KbfxPlasmaCanvasItem (&_pArray,
							     m_canvas);
      _ret->setType (__type);       
//      qDebug("Createing Item");
      return (QCanvasItem *) _ret;
    }


return 0;
}


QCanvasItem *
KbfxPlasmaCanvasItemWrapper::itemIndex (KbfxPlasmaCanvasItem::Type __type)
{

  if (__type == KbfxPlasmaCanvasItem::SEPARATOR)
    {
	static QCanvasPixmapArray  itemPixArray (KbfxPlasmaSkinManager::
						      getThemePixmapPath
						      (KbfxPlasmaSkinManager::
						       INDEXSEPARATOR));
      KbfxPlasmaCanvasItem *_ret =
	new KbfxPlasmaCanvasItem (&itemPixArray,m_canvas);
      _ret->setType (__type);
      return (QCanvasItem *) _ret;
    }

  if (__type == KbfxPlasmaCanvasItem::EXECUTABLE)
    {
      static QCanvasPixmapArray _pArray ( KbfxPlasmaSkinManager::
				getThemePixmapPath (KbfxPlasmaSkinManager::
						    TILENORMAL));

   QCanvasPixmap  * img1 = new QCanvasPixmap (KbfxPlasmaSkinManager::
					    getThemePixmapPath
					    (KbfxPlasmaSkinManager::
					     TILEHOVER));
      _pArray.setImage (1,img1);
      KbfxPlasmaCanvasItem *_ret = new KbfxPlasmaCanvasItem (&_pArray,
							     m_canvas);
      _ret->setType (__type);       
//      qDebug("Createing Item");
      return (QCanvasItem *) _ret;
    }
 if (__type  == KbfxPlasmaCanvasItem::INDEX )
	{
      static QCanvasPixmapArray _pArray ( KbfxPlasmaSkinManager::
				getThemePixmapPath (KbfxPlasmaSkinManager::
						    RHSTILE));

   QCanvasPixmap  * img1 = new QCanvasPixmap (KbfxPlasmaSkinManager::
					    getThemePixmapPath
					    (KbfxPlasmaSkinManager::
					    RHSHOVERTILE));
      _pArray.setImage (1,img1);
      KbfxPlasmaIndexItem *_ret = new KbfxPlasmaIndexItem (&_pArray,
							     m_canvas);
     // _ret->setType (__type);       
      return (QCanvasItem *) _ret;

	}


return 0;
}

#include "kbfxplasmacanvasitemwrapper.moc"
