
#include "kbfxplasmaindexitem.h"
#include <kdesktopfile.h>
#include <kapplication.h>
#include <kbfxconfig.h>

KbfxPlasmaIndexItem::KbfxPlasmaIndexItem( QCanvasPixmapArray * a, QCanvas * canvas ):KbfxPlasmaCanvasAbstractItem(a,canvas)
{
//this->setItemMode (1);
  setAnimated (false); 
  setCurrent(false);
  m_isSelected = false;
   QPixmap *  _img = this->image(0);
	m_height =_img->height();
	m_width= _img->width();

}
	


KbfxPlasmaIndexItem::~KbfxPlasmaIndexItem()
{
}

void
KbfxPlasmaIndexItem::setIcon(QString str)
{
	KIconLoader *iconload = KGlobal::iconLoader ();
	m_iconPath =  iconload->iconPath (str, KIcon::Desktop, false);	

	m_icon.load(m_iconPath);
}

void
KbfxPlasmaIndexItem::setText(QString text)
{
m_text = text;
}

void
KbfxPlasmaIndexItem::setSelected(bool stat)
{
m_isSelected = stat;

}

bool
KbfxPlasmaIndexItem::selected()
{
 return m_isSelected;
}


void
KbfxPlasmaIndexItem::drawContent(QPainter * pe)
{

	if(this->isCurrent() || m_isSelected )
	{	
	this->setFrame(1);
	}
	else
	{
	this->setFrame(0);
	}

 QCanvasPixmap *cp = this->image (this->frame ());
 m_height = cp->height();
 m_width = cp->width();

	 pe->drawPixmap (this->boundingRect (), *cp);

  QRect r ( x(), y(), m_width, m_height);
  QRect textRect ( m_height, y(), m_width,m_height );
  

QFont * _font = new QFont();

_font->setPointSize(ConfigInit().m_fontSize);
pe->setFont(*_font);
pe->setPen(ConfigInit().m_fontIndexColor);

pe->drawText(textRect, Qt::AlignVCenter | Qt::AlignLeft ,QString (m_text),  -1, &r,0); 
pe->drawPixmap(QRect(x()+4,y()+2,m_height-5,m_height-5 ),m_icon);

delete _font;

}

int
KbfxPlasmaIndexItem::height()
{
return m_height;
}

void
KbfxPlasmaIndexItem::setId(int id)
{
m_id = id;
}


void
KbfxPlasmaIndexItem::draw(QPainter & p)
{
	drawContent (&p);
}

void
KbfxPlasmaIndexItem::setLabelText(QString str)
{
QFont * _font = new QFont();
         _font->setPointSize(ConfigInit().m_fontSize);
	
         QFontMetrics fm( *_font );

        int _commentWidth = fm.width(str+".");
        int _strLen = str.length();
        int _margin = height();;
       if(_commentWidth > (m_width  -_margin))
        {

        for(int i = 0; i < _strLen /*&& ( fm.width(str+"...")  < width()-40 )*/ ;i++)
        {
                 str.truncate(str.length()-1);
		if( fm.width(str+".") < m_width-_margin)
                        break;

        }
                str+=".";
       }

setText(str);
}


QString
KbfxPlasmaIndexItem::belongsTo()
{

return m_parent;
}

void
KbfxPlasmaIndexItem::setBelongsTo(QString parent)
{
m_parent = parent;
}


void KbfxPlasmaIndexItem::mousePressEvent ( QMouseEvent * e )
{
e = e;
}

#include "kbfxplasmaindexitem.moc"
