//
// C++ Implementation: kbfxplasmaitemview
//
// Description: 
//
//
// Author: Siraj Razick <siraj@kdemail.net>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kbfxplasmaitemview.h"

KbfxPlasmaItemView::KbfxPlasmaItemView()
{
  viewport ()->setMouseTracking (TRUE);
  viewport()->setAcceptDrops(true);
  this->setVScrollBarMode (QScrollView::AlwaysOff);
  this->setHScrollBarMode (QScrollView::AlwaysOff);
  setFrameShape (QFrame::NoFrame);

	m_currentItem = 0;

}


KbfxPlasmaItemView::~KbfxPlasmaItemView()
{
}


void
KbfxPlasmaItemView::keyPressEvent(QKeyEvent * ke)
{
qDebug("TODO:FIX KEY PRESS EVENTS");
}


void
KbfxPlasmaItemView::mouseMoveEvent (QMouseEvent * me)
{
  QPoint p = inverseWorldMatrix ().map (viewportToContents (me->pos ()));
  if(canvas() == NULL)
	return;

  KbfxPlasmaCanvasGroup *tmp = 0;
  QCanvasItemList l = canvas ()->collisions (p);
  for (QCanvasItemList::Iterator it = l.begin (); it != l.end (); ++it)
    {
	if(*it == 0)
		return ; 
      if ((*it)->rtti () == CANVASITEM)
	{
	  KbfxPlasmaCanvasItem *t = (KbfxPlasmaCanvasItem *) (*it);
	  t->mouseMoveEvent (me);
	  if (m_currentItem != NULL)
	    {
	      m_currentItem->setCurrent (false);
	    }
	  m_currentItem = t;
	  t->setCurrent (true);
	}

    }
  canvas ()->update ();
}
#include "kbfxplasmaitemview.moc"
