/*
 *   Copyright (C) 2006 
 *   Siraj Razick <siraj@kdemail.net>
 *   PhobosK <phobosk@mail.kbfx.org>
 *   see Also ATHORS 
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "kbfxplasmalistboxitem.h"
#include <qpainter.h>
#include <qstyle.h>
#include "kbfxplasmaskinmanager.h"
#include <kdesktopfile.h>
#include <kstandarddirs.h>
#include <kiconloader.h>



KbfxPlasmaListBoxItem::KbfxPlasmaListBoxItem(QListBox * listbox ):QListBoxItem(listbox)
{
	m_text= "";
	m_id = 0;
	setCustomHighlighting ( true) ;
	m_bgNormal = QPixmap(KbfxPlasmaSkinManager::
						      getThemePixmapPath
						      (KbfxPlasmaSkinManager::
						       RHSTILE));
	m_bgHover = QPixmap(KbfxPlasmaSkinManager::getThemePixmapPath(KbfxPlasmaSkinManager::RHSHOVERTILE));
	listbox->resize(m_bgNormal.width(),listbox->height());
	m_mouseOver = 0;
	listBox()->viewport()->setMouseTracking(true);
}

KbfxPlasmaListBoxItem::KbfxPlasmaListBoxItem():QListBoxItem()
{

}

void
KbfxPlasmaListBoxItem::setPos(int x , int y)
{
_x = x;
_y = y;

}

void
KbfxPlasmaListBoxItem::paint(QPainter * painter)
{
 bool in_list_box = listBox() && listBox()->viewport() == painter->device();

    QRect r ( _x, _y, width( listBox() ), height( listBox() ) );
    QRect textRect ( this->height(listBox()), _y, width( listBox() ), height( listBox() ) );
  
	painter->setPen(Qt::black);
	painter->drawPixmap(QRect(_x,_y,m_bgNormal.width(),m_bgNormal.height()),m_bgNormal);
	painter->drawText(textRect, Qt::AlignVCenter | Qt::AlignLeft ,QString (text()),  -1, &r,0); 
	painter->drawPixmap(QRect(_x+4,_y+2,this->height(listBox())-5,this->height(listBox())-5 ),m_icon);

	 if ( in_list_box && isSelected() )
	{ 
		//	painter->eraseRect( r );
	}  
    
	if ( in_list_box && isCurrent() || m_mouseOver == true)
	{
	painter->setPen(Qt::black);
	painter->drawPixmap(QRect(_x,_y,m_bgHover.width(),m_bgHover.height()),m_bgHover);
	painter->drawText(textRect, Qt::AlignVCenter | Qt::AlignLeft ,QString (text()),  -1, &r,0); 
	painter->drawPixmap(QRect(_x+4,_y+2,this->height(listBox())-5,this->height(listBox())-5 ),m_icon);
	 listBox()->style().drawPrimitive( QStyle::PE_FocusRect, painter, r, listBox()->colorGroup() );
	}
    
}

KbfxPlasmaListBoxItem::~KbfxPlasmaListBoxItem()
{
}

void
KbfxPlasmaListBoxItem::setKbfxText(QString str)
{
	m_text = str;
	this->setText(str);
	//delete [] str;
}

void
KbfxPlasmaListBoxItem::setIcon(QString path)
{

	//KStandardDirs::findResource("icon",path);
        KIconLoader *iconload = KGlobal::iconLoader ();

        QString m_iconPath =  iconload->iconPath (path, KIcon::Desktop, false);
       // m_icon.load(m_iconPath);

	m_icon = QPixmap(m_iconPath);

}

QString
KbfxPlasmaListBoxItem::text()
{
	return m_text;
}

#include "kbfxplasmalistboxitem.moc"
