/*
 *   Copyright (C) 2006 
 *   Siraj Razick <siraj@kdemail.net>
 *   PhobosK <phobosk@mail.kbfx.org>
 *   see Also ATHORS 
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "kbfxplasmapluginloader.h"
#include <qdir.h>
#include <qfileinfo.h>
#include <kstandarddirs.h>

KbfxPlasmaPluginLoader::KbfxPlasmaPluginLoader()
{
m_plugin = 0;
//m_canvas = canvas;
init();

}


void
KbfxPlasmaPluginLoader::init()
{

	QString libprefix = locate("lib","libkbfxplasma.so");
	libprefix.remove("libkbfxplasma.so");
	QDir * _dir  = new QDir(libprefix+"/kbfx/plugins/");
	QStringList plugins;
	_dir->setFilter( QDir::Files);
	_dir->setNameFilter("*.so");
	if(!_dir->exists())
	{	
	qDebug("Invalid Plugin Prefix");
	delete _dir;
	return ;//QStringList("No Plugins found: Error in default Paths.Contact Package Manager");
	}
	
	const QFileInfoList *list = _dir->entryInfoList();
	QFileInfoListIterator it( *list );
	QFileInfo *fi=0;
	int _index  =0;
	 while ( (fi = it.current()) != 0 )
	{
	    QString * path   = new QString(libprefix+"/kbfx/plugins/"+fi->fileName());
	    QLibrary * _l = new QLibrary(*path);
	
	    typedef QString (*getName)();
	    getName nameFunc;
	    nameFunc = (getName)_l->resolve("name");
	    if(nameFunc)
	    {
		pluginMap()[nameFunc()] = new  KbfxPlugin(nameFunc(),*path,_index++);
	    }
	    ++it;
	    _l->unload();
	    delete _l;
	    delete path;
//	    if(list!=0)
//		delete list;
//	    if(fi!=0)
//		delete fi;
	//delete list;
        }

//libprefix.~QString();
delete  _dir;
//plugins.~QStringList();

}


KbfxPlasmaPluginLoader::~KbfxPlasmaPluginLoader()
{
  //  if(m_plugin!=0)
//	delete m_plugin;
    
   // PluginMap::Iterator it;
       // for ( it = pluginMap().begin(); it != pluginMap().end(); ++it ) {
           //   delete  it.data();
	//   pluginMap().remove(it);
   //     }


}

QStringList KbfxPlasmaPluginLoader::loadPlugins(QString path)
{


}


KbfxDataStack *
KbfxPlasmaPluginLoader::getView(QString name)
{
 
PluginMap::Iterator it;
        for ( it = pluginMap().begin(); it != pluginMap().end(); ++it ) {
                pluginMap().remove(it);
        }
init();
        KbfxDataStack * stack = pluginMap()[name]->data();
        //delete [] name;
        return stack;

}

KbfxDataGroup * 
KbfxPlasmaPluginLoader::search( QString pname,QString keyword)
{
if(pname == NULL)
	return NULL;

    KbfxDataGroup * group = pluginMap()[pname]->search(keyword);
    if(group == NULL)
    {
	qDebug("KbfxPlasmaaPluginLoader:109:Null pointer");
	return NULL;
    }
	
    return group;

}


KbfxPlasmaPluginLoader::PluginMap& 
KbfxPlasmaPluginLoader::pluginMap()
{
static PluginMap  * map = 0;
if(!map)
	map = new PluginMap();
return *map;
}




QStringList
KbfxPlasmaPluginLoader::scanPlugins()
{

	init();
	QStringList plugins;
	PluginMap::Iterator it;
	printf("Sanced plugins %d\n",pluginMap().count());

	for(it = pluginMap().begin(); it != pluginMap().end();++it)
	{
	if(it.data()->status() == false)
		plugins.append(it.data()->name());
	}
return plugins;
}

#include "kbfxplasmapluginloader.moc"
