#include <kapplication.h>
#include <kservice.h>
#include <kservicegroup.h>
#include <kdebug.h>
#include "kbfxplasmadataplugin.h"




void
browseApp (KServiceGroup::Ptr service, KbfxDataGroupList * glist,
	   KbfxDataGroup * appGroup)
{
  if (!service || !service->isValid ())
    return;


  KServiceGroup::List list = service->entries (true, true, false, true);

/*
  if (service->noDisplay () == true)
    return;


  if (list.count () <= 0)
    return;
*/

  appGroup = new KbfxDataGroup ();
  appGroup->setName (service->caption ());

  for (KServiceGroup::List::ConstIterator it = list.begin ();
       it != list.end (); it++)
    {
      KSycocaEntry *p = (*it);
      if (p->isType (KST_KService))
	{
	  KService *s = static_cast < KService * >(p);
	  KbfxDataSource *data = new KbfxDataSource ();
	  data->setDesktopPath (s->desktopEntryPath ());
	  appGroup->addItem (data);
	}
      else if (p->isType (KST_KServiceGroup))
	{
	  KServiceGroup *g = static_cast < KServiceGroup * >(p);
	  if (g->childCount () > 0)
	    {
	      glist->addGroup (appGroup);
	      appGroup = new KbfxDataGroup ();
	      appGroup->setName (g->caption ());
	      browseApp (g, glist, appGroup);
	    }

	}
    }
//if(appGroup->count() >0) 
  glist->addGroup (appGroup);

}






KbfxDataStack *
view ()
{
  KbfxDataGroup *appGroup = new KbfxDataGroup ();
  KbfxDataGroupList *glist = new KbfxDataGroupList ();
  KbfxDataStack *gstack = new KbfxDataStack ();

  KServiceGroup::Ptr service = KServiceGroup::baseGroup("settings");//KServiceGroup::group ("/");
  service->setShowEmptyMenu (false);

  glist->setName ("Settings");
  appGroup->setName (service->caption ());
//  browseApp (service, glist, appGroup);


  KServiceGroup::List list = service->entries (true, true, false, false);


  for (KServiceGroup::List::ConstIterator it = list.begin ();
       it != list.end (); it++)
    {
      KSycocaEntry *p = (*it);
      if (p->isType (KST_KService))
	{
	}
      else if (p->isType (KST_KServiceGroup))
	{
	  KServiceGroup *g = static_cast < KServiceGroup * >(p);
	  g->setShowEmptyMenu (false);

	  if (g->childCount () > 0)
	    {
	      glist = new KbfxDataGroupList ();
	      glist->setName (g->caption ());
	      glist->setIcon (g->icon ());
	      browseApp (g, glist, appGroup);
	      gstack->addGroupList (glist);
	    }

	}
    }

  gstack->setName ("Settings");


  return gstack;

}

/**
Give a Name to the plugin
you have made.Remember 
Humans will read this
so #d0343erd wan't make much
sence!
**/

QString
name ()
{
  return QString ("Settings");
}

/**
Give the Type of (or kind of items) contained
in this plugin .. make the name prety
beacuse the GUI will display this
as is..
**/

QString
type ()
{
  return QString ("Stub Type");
}


/**
Some kind of a ID but 
still no idea what this
can do..maybe i must
think back..later
**/

uint
id ()
{
  return 1;			//TODO see what can be done... manybe rand()?
}


/**
*DO NOT* Return Null return a empty
Group where the count will be zero..
so that the loader will ignore this
result if no items match in the data
source
**/


#include <ktrader.h>

KbfxDataGroup *
search (QString _keyword)
{

return new KbfxDataGroup();
 
//	qDebug(">>"+check);

  KbfxDataGroup *g = new KbfxDataGroup ();
  g->setName ("Settings");

//  KService::List services = KService::allServices ();

 KTrader::OfferList offers = KTrader::self()->query("Application"); 

  int *count = new int;
  *count = 0;
  QValueListIterator < KService::Ptr > s = offers.begin ();

  for (; s != offers.end (); ++s)
    {
      if (s == NULL)
	 continue;

      QString *sPtr = new QString ();
//      KDesktopFile *desktop = new KDesktopFile ((*s)->desktopEntryPath ());

      (*sPtr) = (*s)->name () +
	(*s)->genericName () +
	(*s)->comment () ;
//+ desktop->readEntry ("Categories", "Application");

//      if (desktop != 0)
//		delete desktop;

      if ((!sPtr->isNull ()) && sPtr->contains (_keyword, false) > 0)
	{
	  KbfxDataSource *data = new KbfxDataSource ();
	  data->setName ((*s)->name ());
	  data->setDesktopPath ((*s)->desktopEntryPath ());

	  g->addItem (data);
	  (*count)++;
	  if ((*count) == 10)
	    break;

	}
      if (sPtr != 0)
	delete sPtr;
    }
  delete count;
  return g;
}

