/*
 *   Copyright (C) 2006 
 *   Siraj Razick <siraj@kdemail.net>
 *   PhobosK <phobosk@mail.kbfx.org>
 *   see Also ATHORS 
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef KBFX_BUTTON_H
#define KBFX_BUTTON_H

#include <qlabel.h>
#include <kbfxconfig.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qpainter.h>

class QPixmap;
class QLabel;

class KbfxButton:public QLabel
{
Q_OBJECT

public:
	KbfxButton( QWidget * parent, const char * name = 0);
	~KbfxButton();
	
       void setImage(QPixmap pix);
	
	void kbfx_vista_button_setFx(bool choice);
 
	
	virtual void paintEvent(QPaintEvent *pe); 
	virtual void enterEvent ( QEvent * e) ;
	virtual void leaveEvent (QEvent * e);
virtual void mousePressEvent ( QMouseEvent * e );

	void readConfig();
	void loadSkin();
	
	
public slots:
	void loadSkins();
	void toggle();
signals:
	void pressed();
	void hideMenu();


protected:
  QPixmap   m_over_skin;
  QPixmap   m_pressed_skin;
  QPixmap   m_release_skin;
  QPixmap   m_normal_skin;
  QPixmap   m_current_skin;


//mng ??
  QTimer * m_anime_timer;
  bool 	    m_anime_on;
  QMovie * m_normal_anime;
  QMovie * m_pressed_anime;
  QMovie * m_hover_anime;
  QMovie * m_current_anime;
  QPixmap * m_buffer; 
 QString    m_normal_path,
		    m_over_path,
		   m_pressed_path;

//state of the button
		bool m_toggle;


};

#endif
