/*
 *   Copyright (C) 2006 
 *   Siraj Razick <siraj@kdemail.net>
 *   PhobosK <phobosk@mail.kbfx.org>
 *   see Also ATHORS 
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


#include <qlcdnumber.h>
#include <kglobal.h>
#include <klocale.h>
#include <kconfig.h>
#include <krun.h>
#include <kapplication.h>
#include <kmessagebox.h>
#include <qlabel.h>
#include <dcopclient.h>
#include <dcopref.h>

#include "kbfxspinx.h"
#include "kbfxspinxview.h"
#include <kbfxplasmaskinmanager.h>
#include <qbitmap.h>



KbfxSpinx::KbfxSpinx(const QString& configFile, Type type, int actions, QWidget *parent, const char *name)
    : KPanelApplet(configFile, type, actions, parent, name),DCOPObject ("kbfxDevelnterface")
{
       
	m_dcopClient = new DCOPClient ();
 	m_dcopClient->attach ();

        kbfxBtn = new KbfxButton(this,"Kbfx Button");	
	kbfxBtn->installEventFilter( this );
	createRMenu();
	connect(kbfxBtn  , SIGNAL(pressed()),this,SLOT(showKbfxMenu()));
        connect(m_menu,SIGNAL(aboutToHide ()),kbfxBtn,SLOT(toggle()));
	if(ConfigInit().m_ToolBarResize)
		parent->resize(parent->width(),kbfxBtn->height());
	

}


void
KbfxSpinx::notifyConfigChange()
{
qDebug("Got dcop Call");
		
delete m_menu;
	createRMenu();
}

void 
KbfxSpinx::createRMenu()
{
        m_menu = new KbfxSpinxPopUp(this,"KbfxOpop");
        m_menuWidget = new KbfxSpinxMenuWidget(m_menu,"KbfxSpinxMenu");
	m_menu->addItem(m_menuWidget,0);
 	kbfxBtn->show();
	kbfxBtn->repaint();
	m_kicker_auto_adjust  = true;
	reajust();
	menuPosition();
}

/*
void
KbfxSpinx::createMask()

{


QPixmap maski(KbfxPlasmaSkinManager::
             getThemePixmapPath (KbfxPlasmaSkinManager::MASK));


QImage maskiimg = maski.convertToImage();

  if (!maski.isNull ())
    {

      if (!maski.mask ())
        {
          if (!maskiimg.hasAlphaBuffer ())
            {
              //qDebug ("Creating AplhaMask");
              QBitmap bitmap;
              bitmap = maskiimg.createAlphaMask ();
              maski.setMask (bitmap);
            }
          else
            {
              //qDebug ("Creating Hurestic Mask");
              QBitmap bitmap;
              bitmap = maskiimg.createHeuristicMask ();
              maski.setMask (bitmap);
            }
        }

      if (maski.mask ())
        m_menu->setMask (*maski.mask ());


    }


}

*/



void
KbfxSpinx::reajust()
{
  if (m_kicker_auto_adjust)
    {
      QByteArray data;
      QDataStream arg (data, IO_WriteOnly);
      arg << kbfxBtn->height ();
      if (!m_dcopClient->send ("kicker", "Panel", "setPanelSize(int)", data))
        kdWarning () << "Could not send DCOP command\n";
    }

}
void
KbfxSpinx::showKbfxMenu()
{
 m_menu->popup (menuPosition());
// this->setCustomMenu (m_menu);
//om_menu->close();
	//m_menuWidget->show();
}

void
KbfxSpinx::showMenu()
{
	showKbfxMenu();
}

KbfxSpinx::~KbfxSpinx()
{
}


void KbfxSpinx::about()
{
    KMessageBox::information(0, i18n("This is an about box"));
}


void KbfxSpinx::help()
{
    KMessageBox::information(0, i18n("This is a help box"));
}


void KbfxSpinx::preferences()
{
//    KMessageBox::information(0, i18n("This is a preferences box"));
    KRun::runCommand ("kbfxconfigapp");
}


void KbfxSpinx::openConfigDialog()
{
    KRun::runCommand ("kbfxconfigapp");
}


int KbfxSpinx::widthForHeight(int height) const
{
    return kbfxBtn->width();
}

int KbfxSpinx::heightForWidth(int width) const
{
    return kbfxBtn->height();
}

void KbfxSpinx::resizeEvent(QResizeEvent *e)
{
 KPanelApplet::resizeEvent (e);
}

QPoint KbfxSpinx::menuPosition()
{
  QRect r = QDesktopWidget ().screenGeometry (this);
  int popy = (r.height () - (m_menuWidget->height() + height ()));
  QPoint xpoint = (this->mapToGlobal (QPoint (0, 0)));
  int popx = xpoint.x ();

  if (position () != pBottom)
    {
      return QPoint (this->mapToGlobal (this->geometry ().bottomLeft ()));
    }

	 return QPoint (popx, popy );
}


void KbfxSpinx::selfDeleter()
{
DCOPRef m_kickerPanel("kicker","Panel");
QStringList returnQStringList =m_kickerPanel.call("listApplets()");
int _myIndex = 0;

QStringList::Iterator it;

for (it = returnQStringList.begin();it != returnQStringList.end();it++)
{
if ((*it).contains("kbfx"))
{
	break;
}
else 
_myIndex++;
}

DCOPRef m_kickerPanelRef("kicker","Panel");
bool returnbool =m_kickerPanelRef.call("removeApplet(int)", _myIndex);

}


bool
KbfxSpinx::eventFilter( QObject *o, QEvent *e )
{

if( e->type() == QEvent::MouseButtonPress )
    {
	QMouseEvent *me = static_cast<QMouseEvent *>( e );
        if( me->button() == QMouseEvent::RightButton )
        {
		qDebug("Hey delete request");	
	
		QPopupMenu *popup = new QPopupMenu();

                popup->insertItem( SmallIcon( "remove" ), i18n("Remove KBFX from Pannel"),
                                   this, SLOT( selfDeleter() ) );
		
 		  popup->insertItem( SmallIcon( "configure" ), i18n("Configure KBFX"),
                                   this, SLOT( openConfigDialog()) );

	
		popup->exec(me->globalPos());
delete popup;		


	return true;	
	}
	else
	return false;
    }


return false;

}

extern "C"
{
    KPanelApplet* init( QWidget *parent, const QString& configFile)
    {
        KGlobal::locale()->insertCatalogue("KbfxSpinx");
        return new KbfxSpinx(configFile, KPanelApplet::Normal,
                             KPanelApplet::About | KPanelApplet::Help | KPanelApplet::Preferences,
                             parent, "KbfxSpinx");
    }
}
#include "kbfxspinx.moc"
