/***************************************************************************
 *   Copyright (C) 2005 by KBFX Team                                       *
 *   http://www.kbfx.org                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef KBFX_SPINX_TOOL_BUTTON_H
#define KBFX_SPINX_TOOL_BUTTON_H

#include <qwidget.h>
#include <qtoolbutton.h>
#include <qpixmap.h>
#include <kbfxdatasource.h>
#include <kbfxdatagroup.h>
#include <qlabel.h>
#include <krun.h>

class KbfxSpinxToolButton:public QLabel
{

Q_OBJECT
	public:
	typedef enum{SINGLE=0,EXPANDABLE} ButtonType;

	KbfxSpinxToolButton(QWidget * parent = 0, const char * name = 0);
	virtual	~KbfxSpinxToolButton();	
	virtual void paintEvent(QPaintEvent * pe);
	
	virtual void enterEvent(QEvent * e);
	virtual void leaveEvent(QEvent * l);
	virtual void mouseReleaseEvent(QMouseEvent * me);
	/*
	virtual void mousePressEvent(QMouseEvent * me);
	*/
	void setDataSource(KbfxDataSource * src);
//	void setDataGroup(KbfxDataGroup * gsrc);
	void setName(QString name){m_name =name;}
	void setExec(QString cmd) { m_exe = cmd;}
	void setType(KbfxSpinxToolButton::ButtonType type){ m_type = type;}
	void setIcon(QString path);
	void setBackground(QPixmap bg);
	void setPixmaps(QPixmap , QPixmap );
signals:
	void clicked();
private:
	QString m_name;
	QString m_exe;
	QString m_icon;
	QString m_tooltip;
	
	QPixmap m_normal;
	QPixmap m_pressed;
	QPixmap m_hover;
	QPixmap m_current;
	QPixmap m_iconPixmap;
	KbfxDataSource * m_dataSource;
	KbfxDataGroup  * m_dataGroup;
	ButtonType m_type;
	bool m_statePressed;
};

#endif
